"use strict";

Object.defineProperty(exports, "__esModule", {
    value: !0
}), exports.WordcloudShapeSemanticMark = void 0;

const semantic_mark_1 = require("./semantic-mark"), vgrammar_core_1 = require("@visactor/vgrammar-core"), enums_1 = require("./enums"), vgrammar_util_1 = require("@visactor/vgrammar-util"), vutils_1 = require("@visactor/vutils");

class WordcloudShapeSemanticMark extends semantic_mark_1.SemanticMark {
    constructor(id) {
        super(enums_1.PlotMakType.wordcloudShape, id), vgrammar_core_1.Factory.getTransform(enums_1.PlotMakType.wordcloudShape) || this._logger.error("Please add this line of code:\n          import { registerWordCloudShapeTransforms } from '@visactor/vgrammar-wordcloud-shape'; \n        and run registerWordCloudShapeTransforms() before use wordcloud-shape");
    }
    setMarkType() {
        return vgrammar_core_1.GrammarMarkType.text;
    }
    setDefaultMarkTransform() {
        var _a;
        return [ {
            type: "wordcloudShape",
            size: {
                callback: params => [ params.viewBox.width(), params.viewBox.height() ],
                dependency: [ "viewBox" ]
            },
            dataIndexKey: "text_key",
            colorList: this.getPalette(),
            text: {
                field: null === (_a = this.spec.encode) || void 0 === _a ? void 0 : _a.text
            }
        } ];
    }
    setMainMarkSpec(parsedMainSpec) {
        var _a;
        const shapeTransform = parsedMainSpec.transform ? parsedMainSpec.transform.find((entry => "wordcloudShape" === entry.type)) : null;
        return shapeTransform ? {
            key: null !== (_a = shapeTransform.dataIndexKey) && void 0 !== _a ? _a : "defaultDataIndexKey"
        } : {};
    }
    setMainMarkEnterEncode() {
        return (0, vutils_1.merge)({
            textAlign: "center",
            textBaseline: "alphabetic"
        }, this.spec.style);
    }
    parseScaleByEncode(channel, option) {
        return "color" === channel ? {
            type: "ordinal",
            id: this.getScaleId("color"),
            domain: {
                data: this.getDataIdOfFiltered(),
                field: option
            },
            range: this.getPalette()
        } : null;
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d;
        const markEncoder = this.convertSimpleMarkEncode(encode), res = {
            x: {
                field: "x"
            },
            y: {
                field: "y"
            },
            angle: {
                field: "angle"
            },
            fontSize: {
                field: "fontSize"
            },
            fontStyle: {
                field: "fontStyle"
            },
            fontFamily: {
                field: "fontFamily"
            },
            fontWeight: {
                field: "fontWeight"
            },
            fillOpacity: {
                field: "opacity"
            },
            text: {
                field: null === (_a = this.spec.encode) || void 0 === _a ? void 0 : _a.text
            }
        };
        if (markEncoder.stroke && (res.stroke = markEncoder.stroke), markEncoder.color) {
            const scaleColorId = this.getScaleId("color"), colorAccessor = (0, vgrammar_util_1.field)(markEncoder.color.field);
            res.fill = (datum, el, params) => params[scaleColorId].scale(colorAccessor(datum));
        } else res.fill = null !== (_c = null === (_b = this.spec.style) || void 0 === _b ? void 0 : _b.fill) && void 0 !== _c ? _c : null === (_d = this.getPalette()) || void 0 === _d ? void 0 : _d[0];
        return res;
    }
    parseLabelSpec() {
        return {
            marks: [],
            interactions: []
        };
    }
}

exports.WordcloudShapeSemanticMark = WordcloudShapeSemanticMark, WordcloudShapeSemanticMark.type = enums_1.PlotMakType.wordcloudShape;
//# sourceMappingURL=wordcloud-shape.js.map