import type { SymbolEncodeChannels, WithDefaultEncode, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, BasicEncoderSpecMap, SemanticTooltipOption, CrosshairSpec } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class SymbolSemanticMark extends SemanticMark<BasicEncoderSpecMap['symbol'], SymbolEncodeChannels> {
    static defaultSpec: BasicEncoderSpecMap['symbol'];
    static readonly type = PlotMakType.symbol;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    protected parseScaleOfEncodeX(option: ValueOf<WithDefaultEncode<BasicEncoderSpecMap['symbol'], SymbolEncodeChannels>, SymbolEncodeChannels>): ScaleSpec | Nil;
    setDefaultCrosshair(): Record<string, Pick<CrosshairSpec, 'crosshairShape' | 'crosshairType'>>;
    setDefaultTooltip(): SemanticTooltipOption | Nil;
    parseScaleByEncode(channel: SymbolEncodeChannels, option: ValueOf<WithDefaultEncode<BasicEncoderSpecMap['symbol'], SymbolEncodeChannels>, SymbolEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<BasicEncoderSpecMap['symbol'], SymbolEncodeChannels>): GenerateBaseEncodeSpec<BasicEncoderSpecMap['symbol']>;
}
